/**
 * Autogenerated by Thrift Compiler (0.13.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.eclipse.hawk.service.api;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@javax.annotation.Generated(value = "Autogenerated by Thrift Compiler (0.13.0)", date = "2021-04-18")
public class HawkFactoryNotFound extends org.apache.thrift.TException implements org.apache.thrift.TBase<HawkFactoryNotFound, HawkFactoryNotFound._Fields>, java.io.Serializable, Cloneable, Comparable<HawkFactoryNotFound> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("HawkFactoryNotFound");

  private static final org.apache.thrift.protocol.TField FACTORY_NAME_FIELD_DESC = new org.apache.thrift.protocol.TField("factoryName", org.apache.thrift.protocol.TType.STRING, (short)1);

  private static final org.apache.thrift.scheme.SchemeFactory STANDARD_SCHEME_FACTORY = new HawkFactoryNotFoundStandardSchemeFactory();
  private static final org.apache.thrift.scheme.SchemeFactory TUPLE_SCHEME_FACTORY = new HawkFactoryNotFoundTupleSchemeFactory();

  public @org.apache.thrift.annotation.Nullable java.lang.String factoryName; // optional

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    FACTORY_NAME((short)1, "factoryName");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // FACTORY_NAME
          return FACTORY_NAME;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final _Fields optionals[] = {_Fields.FACTORY_NAME};
  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.FACTORY_NAME, new org.apache.thrift.meta_data.FieldMetaData("factoryName", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(HawkFactoryNotFound.class, metaDataMap);
  }

  public HawkFactoryNotFound() {
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public HawkFactoryNotFound(HawkFactoryNotFound other) {
    if (other.isSetFactoryName()) {
      this.factoryName = other.factoryName;
    }
  }

  public HawkFactoryNotFound deepCopy() {
    return new HawkFactoryNotFound(this);
  }

  @Override
  public void clear() {
    this.factoryName = null;
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getFactoryName() {
    return this.factoryName;
  }

  public HawkFactoryNotFound setFactoryName(@org.apache.thrift.annotation.Nullable java.lang.String factoryName) {
    this.factoryName = factoryName;
    return this;
  }

  public void unsetFactoryName() {
    this.factoryName = null;
  }

  /** Returns true if field factoryName is set (has been assigned a value) and false otherwise */
  public boolean isSetFactoryName() {
    return this.factoryName != null;
  }

  public void setFactoryNameIsSet(boolean value) {
    if (!value) {
      this.factoryName = null;
    }
  }

  public void setFieldValue(_Fields field, @org.apache.thrift.annotation.Nullable java.lang.Object value) {
    switch (field) {
    case FACTORY_NAME:
      if (value == null) {
        unsetFactoryName();
      } else {
        setFactoryName((java.lang.String)value);
      }
      break;

    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.Object getFieldValue(_Fields field) {
    switch (field) {
    case FACTORY_NAME:
      return getFactoryName();

    }
    throw new java.lang.IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new java.lang.IllegalArgumentException();
    }

    switch (field) {
    case FACTORY_NAME:
      return isSetFactoryName();
    }
    throw new java.lang.IllegalStateException();
  }

  @Override
  public boolean equals(java.lang.Object that) {
    if (that == null)
      return false;
    if (that instanceof HawkFactoryNotFound)
      return this.equals((HawkFactoryNotFound)that);
    return false;
  }

  public boolean equals(HawkFactoryNotFound that) {
    if (that == null)
      return false;
    if (this == that)
      return true;

    boolean this_present_factoryName = true && this.isSetFactoryName();
    boolean that_present_factoryName = true && that.isSetFactoryName();
    if (this_present_factoryName || that_present_factoryName) {
      if (!(this_present_factoryName && that_present_factoryName))
        return false;
      if (!this.factoryName.equals(that.factoryName))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int hashCode = 1;

    hashCode = hashCode * 8191 + ((isSetFactoryName()) ? 131071 : 524287);
    if (isSetFactoryName())
      hashCode = hashCode * 8191 + factoryName.hashCode();

    return hashCode;
  }

  @Override
  public int compareTo(HawkFactoryNotFound other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = java.lang.Boolean.valueOf(isSetFactoryName()).compareTo(other.isSetFactoryName());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetFactoryName()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.factoryName, other.factoryName);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  @org.apache.thrift.annotation.Nullable
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    scheme(iprot).read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    scheme(oprot).write(oprot, this);
  }

  @Override
  public java.lang.String toString() {
    java.lang.StringBuilder sb = new java.lang.StringBuilder("HawkFactoryNotFound(");
    boolean first = true;

    if (isSetFactoryName()) {
      sb.append("factoryName:");
      if (this.factoryName == null) {
        sb.append("null");
      } else {
        sb.append(this.factoryName);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class HawkFactoryNotFoundStandardSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public HawkFactoryNotFoundStandardScheme getScheme() {
      return new HawkFactoryNotFoundStandardScheme();
    }
  }

  private static class HawkFactoryNotFoundStandardScheme extends org.apache.thrift.scheme.StandardScheme<HawkFactoryNotFound> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, HawkFactoryNotFound struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // FACTORY_NAME
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.factoryName = iprot.readString();
              struct.setFactoryNameIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, HawkFactoryNotFound struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.factoryName != null) {
        if (struct.isSetFactoryName()) {
          oprot.writeFieldBegin(FACTORY_NAME_FIELD_DESC);
          oprot.writeString(struct.factoryName);
          oprot.writeFieldEnd();
        }
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class HawkFactoryNotFoundTupleSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public HawkFactoryNotFoundTupleScheme getScheme() {
      return new HawkFactoryNotFoundTupleScheme();
    }
  }

  private static class HawkFactoryNotFoundTupleScheme extends org.apache.thrift.scheme.TupleScheme<HawkFactoryNotFound> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, HawkFactoryNotFound struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol oprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet optionals = new java.util.BitSet();
      if (struct.isSetFactoryName()) {
        optionals.set(0);
      }
      oprot.writeBitSet(optionals, 1);
      if (struct.isSetFactoryName()) {
        oprot.writeString(struct.factoryName);
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, HawkFactoryNotFound struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol iprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet incoming = iprot.readBitSet(1);
      if (incoming.get(0)) {
        struct.factoryName = iprot.readString();
        struct.setFactoryNameIsSet(true);
      }
    }
  }

  private static <S extends org.apache.thrift.scheme.IScheme> S scheme(org.apache.thrift.protocol.TProtocol proto) {
    return (org.apache.thrift.scheme.StandardScheme.class.equals(proto.getScheme()) ? STANDARD_SCHEME_FACTORY : TUPLE_SCHEME_FACTORY).getScheme();
  }
}

